#include "BoatyMusic.h"

#include <Framework/SoundLibrary.h>

void BoatyMusic::load()
{
	for (auto& musicClip : musicClips)
	{
		const auto clipPath = "Music/" + musicClip + ".wav";
		g_sounds[musicClip] = jamLoadSoundClip(clipPath.c_str());
		g_sounds[musicClip].doneCallback = std::bind(&BoatyMusic::doneMusic, this);
	}
}

void BoatyMusic::playMusic()
{
	if (musicChannel > -1)
		return;

	int clip = (rand() % musicClips.size());
	auto iter = g_sounds.find(musicClips[clip].c_str());
	if (iter != g_sounds.end())
	{
		musicChannel = jamPlaySound(iter->second);
	}
}

void BoatyMusic::stopMusic()
{
	if (musicChannel > -1)
	{
		jamStopSound(musicChannel);
		musicChannel = -1;
	}
}

void BoatyMusic::doneMusic()
{
	musicChannel = -1;
}
