#include "CameraShake.h"

void CameraShake::start(float duration, float howExtreme, float cooldown_)
{
	timer = duration;
	radius = howExtreme;
	randomAngle = randomUnitFloat() * 2 * (float)M_PI;
	cooldown = cooldown_;

	offset = vec2(sin(randomAngle) * radius, cos(randomAngle) * radius);
}

bool CameraShake::running() { return timer > 0; }

void CameraShake::update(float dt)
{
	timer -= dt;
	radius *= cooldown;
	float s = (float)(rand() & 1 ? -1 : 1);
	randomAngle += ((float)M_PI * s * (randomUnitFloat() * (float)M_PI / 3.0f));
	offset = vec2(sin(randomAngle) * radius, cos(randomAngle) * radius);
}
