#include "GridRenderer.h"
#include <Framework/PrimitiveBatch.h>

void GridRenderer::drawTiles(GfxContext* ctx, PrimitiveBatch* prim)
{
	BlendStateHandle blendState_solid = Gfx_BlendState_Create(g_device, BlendStateDescr::make_solid());
	Gfx_SetBlendState(ctx, blendState_solid);
	prim->setLineWidth(4.0f);

	int tileSize = 50;

	vec2 drawPos = startPoint;

	for (int y = 0; y < gridSize.y; y += tileSize)
	{
		vec2 mapStart(0, y);
		vec2 mapEnd(gridSize.x, y);

		vec2 screenStart(
			mapStart.x - mapStart.y,
			(mapStart.x + mapStart.y) / 2);

		vec2 screenEnd(
			mapEnd.x - mapEnd.y,
			(mapEnd.x + mapEnd.y) / 2);

		screenStart += drawPos;
		screenEnd += drawPos;

		prim->drawLine(screenStart, screenEnd, ColorRGBA8(0xffeeeeee));
	}

	for (int x = 0; x < gridSize.x; x += tileSize)
	{
		vec2 mapStart(x, 0);
		vec2 mapEnd(x, gridSize.y);

		vec2 screenStart(
			mapStart.x - mapStart.y,
			(mapStart.x + mapStart.y) / 2);

		vec2 screenEnd(
			mapEnd.x - mapEnd.y,
			(mapEnd.x + mapEnd.y) / 2);

		screenStart += drawPos;
		screenEnd += drawPos;

		prim->drawLine(screenStart, screenEnd, ColorRGBA8(0xffeeeeee));
	}
}
