#include "ParticleSystem.h"
#include <assert.h>

float randFloat()
{
	return randomUnitFloat();
}

ParticleSystem::ParticleSystem()
{
}

Particle& ParticleSystem::addParticle()
{
	// +y = up
	Particle& p = giantParticleArray[particleCount];
	
	p.position = vec3(1280/2, 0, 720/2);
	p.velocity = vec3(randFloat() * 2 - 1, 0, randFloat() * 2 - 1) * vec3(0.2f);
	p.acceleration = vec3(0, 0, -0.00098);
	p.life = 1000.0f * randFloat();
	p.size = vec3(randFloat(), randFloat(), randFloat());
	p.color = ColorRGBA8(185, 122, 87);
	particleCount++;

	assert(particleCount < giantArraySize);

	return p;
}

void ParticleSystem::update(float dt)
{
	for (int i = 0; i < particleCount; i++)
	{
		Particle& p = giantParticleArray[i];
		p.life -= dt;

		if (!p.isAlive())
		{
			// kill particle
			particleCount--;
			p = giantParticleArray[particleCount];
		}
		else
		{
			p.velocity += p.acceleration * dt;
			p.position += p.velocity * dt;
		}
	}
}
