#pragma once

#include "Framework/Color.h"
#include "Common.h"

struct Particle
{
	vec3 position;
	vec3 velocity;
	vec3 acceleration;
	vec3 size;
	ColorRGBA color;
	float life;
	int type;

	bool isAlive() const { return life > 0; }
};

class ParticleSystem
{
public:
	static const int giantArraySize = 1 << 20;
	Particle giantParticleArray[giantArraySize];
	int particleCount = 0;

	ParticleSystem();

	Particle& addParticle();
	void update(float dt);

	template<typename _Fn>
	void draw(_Fn fn)
	{
		for (int i = 0; i < particleCount; i++)
		{
			Particle& p = giantParticleArray[i];
			if (p.isAlive())
				fn(p);
		}
	}
};