#pragma once

#include <Framework/Framework.h>

#include "Raft.h"

#include <unordered_map>
#include <string>
#include <random>


struct WeightedRaftPartLibrary {
	WeightedRaftPartLibrary(std::vector<RaftPartBlueprint*> blueprints);

	RaftPartBlueprint* draw() {
		return items[distrib(gen)];
	}

private:
	std::vector<RaftPartBlueprint*> items;
	std::vector<double> weights;
	std::discrete_distribution<int> distrib;
	std::mt19937 gen;
};

class RaftPartLibrary
{
public:
	RaftPartLibrary(const char* filename);

	RaftPartBlueprint* get(const char* name)
	{
		auto it = library.find(name);
		if (it == library.end()) { return nullptr; }
		else { return &it->second; }
	}

	RaftPartBlueprint* getRandom()
	{
		/*while (true) {
			auto random_it = std::next(std::begin(library), rand() % library.size());
			auto res = &random_it->second;
			if (res->generate) {
				return res;
			}
		}*/

		return weightedLibrary->draw();
	}

	std::unordered_map<std::string, RaftPartBlueprint> library;
	WeightedRaftPartLibrary* weightedLibrary = nullptr;
};

extern RaftPartLibrary* g_raftPartLibrary;
