#pragma once

#include <Framework/Framework.h>
#include <Framework/Graphics.h>

#include "Raft.h"
#include "Debris.h"

class Rafterizer
{
public:

	void reset();
	void add(const Raft& raft);
	void add(const Debris& debris, Sprite* sprite);
	void render();

	struct Element
	{
		Sprite* sprite;
		vec2 pos;
		float sortPos;
		const BoatyBase *obj;
	};

	std::vector<Element> m_elements;
	bool m_enableHealthBars = false;

	void sortElements();
};

