#include <Framework/Framework.h>
#include "Entity.h"

#if 0
std::vector<Entity> g_entities;
std::vector<int> g_entityConnectedPrefabs;
EntityPool g_entityPool;
std::unordered_map<std::string, EntityPrefab*> g_entityPrefabs;
std::vector<EntityPrefab*> g_entityPrefabsById;

std::unordered_map<std::string, std::function<IComponent*()>>& g_componentProtoFactories()
{
	static std::unordered_map<std::string, std::function<IComponent*()>> inst;
	return inst;
}

std::vector<ComponentInfo*>& g_componentInfo()
{
	static std::vector<ComponentInfo*> inst;
	return inst;
}

cJSON* marshallEntity(Entity ent) {
	cJSON* json = cJSON_CreateObject();
	cJSON* componentsArray = cJSON_CreateArray();

	const int connectedPrefab = g_entityConnectedPrefabs[ent.getId()];
	if (connectedPrefab != -1) {
		cJSON_AddStringToObject(json, "prefab", g_entityPrefabsById[connectedPrefab]->getName().c_str());
	}

	cJSON_AddItemToObject(json, "components", componentsArray);

	iterateEntityComponents(ent, [&](IComponent* comp) {
		const ReflectionBase& refl = comp->getReflection();
		const IComponent* componentInitializer = nullptr;
		if (connectedPrefab != -1) {
			componentInitializer = g_entityPrefabsById[connectedPrefab]->getComponentInitializer(&comp->getReflection());
		}
		cJSON* obj = marshallObjectDiff(comp, componentInitializer, refl);
		cJSON_AddItemToArray(componentsArray, obj);
	});

	return json;
}

cJSON* marshallAllEntities() {
	cJSON* entities = cJSON_CreateArray();
	for (Entity ent : g_entities) {
		cJSON_AddItemToArray(entities, marshallEntity(ent));
	}
	return entities;
}

void demarshallEntity(cJSON* json, Entity ent) {
	cJSON* componentsJson = cJSON_GetObjectItem(json, "components");
	const int componentCount = cJSON_GetArraySize(componentsJson);
	for (int i = 0; i < componentCount; ++i) {
		cJSON* componentJson = cJSON_GetArrayItem(componentsJson, i);
		const char* const componentName = cJSON_GetObjectItem(componentJson, "name")->valuestring;
		IComponent* component = g_componentProtoFactories()[componentName]()->createForEntity(ent);
		demarshallObjectFields(cJSON_GetObjectItem(componentJson, "fields"), component, component->getReflection());
	}
}

void demarshallEntities(cJSON* json) {
	for (cJSON* it = json->child; it; it = it->next) {
		cJSON* prefabNameJson = cJSON_GetObjectItem(it, "prefab");

		Entity ent;
		if (prefabNameJson) {
			ent = g_entityPrefabs[prefabNameJson->valuestring]->create();
		} else {
			ent = g_entityPool.allocate();
		}

		demarshallEntity(it, ent);
	}
}

EntityPrefab* createPrefab(const std::string& name) {
	int nextId = 0;
	EntityPrefab* res = new EntityPrefab(nextId++);
	g_entityPrefabs[name] = res;
	g_entityPrefabsById.push_back(res);
	res->name = name;
	return res;
}

cJSON* marshallAllPrefabs() {
	cJSON* prefabs = cJSON_CreateObject();
	for (const auto& it : g_entityPrefabs) {
		cJSON_AddItemToObject(prefabs, it.first.c_str(), it.second->marshall());
	}
	return prefabs;
}

void demarshallPrefabs(cJSON* json) {
	for (cJSON* it = json->child; it; it = it->next) {
		EntityPrefab* prefab = createPrefab(it->string);
		prefab->demarshall(it);
	}
}

Entity EntityPrefab::create() {
	Entity ent = g_entityPool.allocateConnectedToPrefab(thisPrefabId);
	for (IComponentFactory* fact : componentFactories) {
		fact->createComponent(ent);
	}
	return ent;
}
#endif
