#include "GameWorld.h"
#include "PhysicsDebugDraw.h"

GameWorld::GameWorld(const vec2& gravity, float physicsWorldScale)
{
	physicsWorld = new b2World(gravity);
	physicsDebugDraw = new PhysicsDebugDraw(physicsWorldScale);
	physicsWorld->SetDebugDraw(physicsDebugDraw);
}

GameWorld::~GameWorld()
{
	physicsWorld->SetDebugDraw(nullptr);
	delete physicsDebugDraw;

	delete physicsWorld;
}

void GameWorld::registerObjectFactory(const char *type, std::function<GameObject*()> fn)
{
	factory[type] = fn;
}

