#pragma once

#include "Framework.h"
#include "Physics.h"
#include "GameObject.h"

#include <functional>
#include <map>

class PhysicsDebugDraw;

class GameWorld
{
public:

	GameWorld(const vec2& gravity, float physicsWorldScale);
	virtual ~GameWorld();

	void registerObjectFactory(const char *type, std::function<GameObject*()> fn);

	template<typename T>
	T* get(const std::string& name)
	{
		if (gameObjects.find(name) == gameObjects.end())
			return nullptr;

		return static_cast<T*>(gameObjects[name]);
	}

	std::map<std::string, std::function<GameObject*()>> factory;
	std::map<std::string, GameObject *> gameObjects;
	b2World *physicsWorld;
	PhysicsDebugDraw *physicsDebugDraw;
};

