#pragma once

#include "Framework.h"
#include "Graphics.h"

class Image
{
public:

	Image();
	~Image();

	bool create(u32 w, u32 h, GfxFormat format);

	u32 width() const { return m_width; }
	u32 height() const { return m_height; }
	GfxFormat format() const { return m_format; }

	const u8* data() const { return m_data; }
	u8* data() { return m_data; }

	inline u32 data_size_in_bytes() const { return m_data_size_in_bytes; }

	//bool read_dds(DataStream& stream);
	//bool load_dds(const char* filename);
	//bool save_tga(const char* filename);

private:

	GfxFormat			m_format;

	u32				m_width;
	u32				m_height;

	u8*				m_data;
	u32              m_data_size_in_bytes;

};