#include "JsonUtil.h"
#include <rapidjson/document.h>

static constexpr u32 RapidJsonParseFlags = (rapidjson::kParseCommentsFlag | rapidjson::kParseTrailingCommasFlag);

bool jsonGetValue(cJSON* obj, const char* name, int& out)
{
	cJSON* val = cJSON_GetObjectItem(obj, name);
	if (val && val->type == cJSON_Number)
	{
		out = val->valueint;
		return true;
	}
	else
	{
		return false;
	}
}

bool jsonGetValue(cJSON* obj, const char* name, float& out)
{
	cJSON* val = cJSON_GetObjectItem(obj, name);
	if (val && val->type==cJSON_Number)
	{
		out = (float)val->valuedouble;
		return true;
	}
	else
	{
		return false;
	}
}

bool jsonGetValue(cJSON* obj, const char* name, std::string& out)
{
	cJSON* val = cJSON_GetObjectItem(obj, name);
	if (val && val->type==cJSON_String)
	{
		out = val->valuestring;
		return true;
	}
	else
	{
		return false;
	}
}

JsonDocument jsonParseFromFile(const char* filename)
{
	JsonDocument document;
	char* fileData = jamReadFile(filename);
	if (document.Parse<RapidJsonParseFlags>(fileData).HasParseError())
	{
		SDL_assert(!"Script parse error"); // TODO: get error string from rapidjson
		return document;
	}
	SDL_free(fileData);
	return document;
}

const char* jsonGetParseError(const JsonDocument& document)
{
	return "<TODO>";
}
