#pragma once

extern "C" {
	#include <lua.h>
	#include <lauxlib.h>
	#include <lualib.h>
}
#include <LuaBridge/LuaBridge.h>

using luabridge::LuaRef;


struct LuaScript: LuaRef {
	LuaScript()
		: L(luaL_newstate())
		, LuaRef(L)
	{
		luaL_openlibs(L);
	}

	~LuaScript() {
		lua_close(L);
	}

	bool load(const char *const path) {
	    if (luaL_dofile(L, path)) {
			fprintf(stderr, "%s\n", lua_tostring(L, -1));
			return false;
		} else {
			return true;
		}
	}

	LuaRef getGlobal(const char *const name) {
		return LuaRef::getGlobal(L, name);
	}

	lua_State* L = nullptr;

private:
	LuaScript& operator= (const LuaScript&);
};
