#include "Math.h"

float signedTriArea(vec2 a, vec2 b, vec2 c)
{
	return (a.x - c.x) * (b.y - c.y) - (a.y - c.y) * (b.x - c.x);
}

bool intersectLineLine(line2 lineA, line2 lineB, vec2* outPos)
{
	vec2 a = lineA.a;
	vec2 b = lineA.b;
	vec2 c = lineB.a;
	vec2 d = lineB.b;

	float a1 = signedTriArea(a, b, d);
	float a2 = signedTriArea(a, b, c);

	if (a1 * a2 < 0.0f)
	{
		float a3 = signedTriArea(c, d, a);
		float a4 = a3 + a2 - a1;

		if (a3 * a4 < 0.0f)
		{
			if (outPos)
			{
				float t = a3 / (a3 - a4);
				*outPos = a + t * (b - a);
			}

			return true;
		}
	}

	return false;
}

bool intersectBoxBox(aabb2 boxA, aabb2 boxB)
{
	if (boxA.max.x < boxB.min.x || boxA.min.x > boxB.max.x) return false;
	if (boxA.max.y < boxB.min.y || boxA.min.y > boxB.max.y) return false;

	return true;
}

bool intersectPointBox(vec2 p, aabb2 box)
{
	if (p.x < box.min.x || p.x > box.max.x) return false;
	if (p.y < box.min.y || p.y > box.max.y) return false;

	return true;
}
