#include <Framework/Framework.h>
#include "Reflection.h"

void ReflectionBase::ReflectionConstruct()
{
	//  todo: register myself in some table, etc
	members();
	memberCount();
	name();
	size();
}

void demarshallObjectFields(const cJSON* fields, void *const obj, const ReflectionBase& info)
{
	for (size_t i = 0; i != info.memberCount(); ++i) {
		const member_t& member = info.members()[i];
		cJSON* memberJson = cJSON_GetObjectItem(const_cast<cJSON*>(fields), member.name);
		if (memberJson) {
			member.type->demarshal(memberJson, (char*)obj + member.offset);
		}
	}
}

cJSON* marshallObjectFieldsDiff(const void *const obj, const void *const baseObj, const ReflectionBase& info) {
	cJSON* fields = cJSON_CreateObject();

	for (size_t i = 0; i != info.memberCount(); ++i) {
		const member_t& member = info.members()[i];
		if (!baseObj || !member.type->equal((char*)obj + member.offset, (char*)baseObj + member.offset)) {
			cJSON* itemJson = member.type->marshal((char*)obj + member.offset);
			if (itemJson) {
				cJSON_AddItemToObject(fields, member.name, itemJson);
			}
		}
	}

	return fields;
}

cJSON* marshallObjectFields(const void *const obj, const ReflectionBase& info) {
	return marshallObjectFieldsDiff(obj, nullptr, info);
}

cJSON* marshallObjectDiff(const void *const obj, const void *const baseObj, const ReflectionBase& info) {
	cJSON* json = cJSON_CreateObject();
	cJSON_AddStringToObject(json, "name", info.name());

	cJSON* fields = marshallObjectFieldsDiff(obj, baseObj, info);
	cJSON_AddItemToObject(json, "fields", fields);

	return json;
}

cJSON* marshallObject(const void *const obj, const ReflectionBase& info) {
	return marshallObjectDiff(obj, nullptr, info);
}
