#pragma once

#include "Math.h"

class GameObject;

struct StateMod {
	virtual void	apply(GameObject *const) {}
	virtual void	process(GameObject *const) {}
	virtual void	finalize(GameObject *const) {}
	virtual void	modifyColorOverlay(vec4 *const) {}

	float	lifeRemaining = 0.f;
	int		priority = 0;
};


void updateStateMods(GameObject *const obj, const float dt);



struct DyingStateMod : StateMod {
	virtual void apply(GameObject *const obj) override;
	virtual void finalize(GameObject *const obj) override;

private:
	float amount = 0;
};


struct DamageStateMod : StateMod {
	DamageStateMod(int amount_, bool playSound = true);
	virtual void apply(GameObject *const obj) override;
	virtual void modifyColorOverlay(vec4 *const) override;

private:
	int amount = 0;
	bool playSound = true;
};
