#pragma once

#include "Framework.h"

#include <map>
#include <string>

struct Sprite;
class TextureLibrary
{
public:

	std::map<std::string, std::string> filenames;
	std::map<std::string, Sprite*> library;
	std::string filename;

	u32 defaultColorKey = 0xff00ff;
	bool defaultClip = true;
	bool defaultRepeat = false;

	void load(const char *filename);
	void reload();
	bool hasSprite(const char *name);
	Sprite *getSprite(const char *name);
	Sprite *getSprite(const std::string& name);
	const char *getFilename(const char *name);
};

extern TextureLibrary* g_textureLibrary;
